<?php

class fieldtype_auto_increment
{
	public $options;

	function __construct()
	{
		$this->options = array('title' => TEXT_FIELDTYPE_AUTO_INCREMENT_TITLE);
	}

	function get_configuration()
	{
		$cfg = array();

		$cfg[] = array('title'=>TEXT_ALLOW_SEARCH, 'name'=>'allow_search','type'=>'checkbox','tooltip_icon'=>TEXT_ALLOW_SEARCH_TIP);

		$cfg[] = array('title'=>TEXT_WIDHT,
				'name'=>'width',
				'type'=>'dropdown',
				'choices'=>array('input-small'=>TEXT_INPTUT_SMALL,'input-medium'=>TEXT_INPUT_MEDIUM,'input-large'=>TEXT_INPUT_LARGE,'input-xlarge'=>TEXT_INPUT_XLARGE),
				'tooltip_icon'=>TEXT_ENTER_WIDTH,
				'params'=>array('class'=>'form-control input-medium'));
		 
		$cfg[] = array('title'=>TEXT_HIDE_FIELD_IF_EMPTY, 'name'=>'hide_field_if_empty','type'=>'checkbox','tooltip_icon'=>TEXT_HIDE_FIELD_IF_EMPTY_TIP);

		$cfg[] = array('title'=>TEXT_IS_UNIQUE_FIELD_VALUE, 'name'=>'is_unique','type'=>'checkbox','tooltip_icon'=>TEXT_IS_UNIQUE_FIELD_VALUE_TIP);
		$cfg[] = array('title'=>TEXT_ERROR_MESSAGE, 'name'=>'unique_error_msg','type'=>'input','tooltip_icon'=>TEXT_UNIQUE_FIELD_VALUE_ERROR_MSG_TIP,'tooltip'=>TEXT_DEFAULT . ': ' . TEXT_UNIQUE_FIELD_VALUE_ERROR,'params'=>array('class'=>'form-control input-xlarge'));

		return $cfg;
	}

	function render($field,$obj,$params = array())
	{
		$cfg =  new fields_types_cfg($field['configuration']);

		$attributes = array('class'=>'form-control ' . $cfg->get('width') .
				' fieldtype_input field_' . $field['id'] .
				($field['is_heading']==1 ? ' autofocus':'') .
				($field['is_required']==1 ? ' required noSpace':'') .
				($cfg->get('is_unique')==1 ? ' is-unique':'')
		);
		
		if(isset($params['is_new_item']))
		{		
			if($params['is_new_item']==1)
			{
				$check_query = db_query("select (max(field_{$field['id']}+0)+1) as max_value from app_entity_{$field['entities_id']}");
				$check = db_fetch_array($check_query);
				$obj['field_' . $field['id']] = $check['max_value'];
			}
		}

		$attributes = fields_types::prepare_uniquer_error_msg_param($attributes,$cfg);

		return input_tag('fields[' . $field['id'] . ']',$obj['field_' . $field['id']],$attributes);
	}

	function process($options)
	{
		return db_prepare_input($options['value']);
	}

	function output($options)
	{
		return $options['value'];
	}
	
	function reports_query($options)
	{
		$filters = $options['filters'];
		$sql_query = $options['sql_query'];
	
		$sql = reports::prepare_numeric_sql_filters($filters, $options['prefix']);
	
		if(count($sql)>0)
		{
			$sql_query[] =  implode(' and ', $sql);
		}
	
		return $sql_query;
	}
}